[LeetCode0001E] Two Sum

Given an array of integers, return indices of the two numbers such that they add up to a specific target.

You may assume that each input would have exactly one solution, and you may not use the same element twice.

Example:

Given nums = [2, 7, 11, 15], target = 9,

Because nums[0] + nums[1] = 2 + 7 = 9,
return [0, 1].

Solution 1: Brute Force

public int[] towSum(int[] nums, int target) {
    for(int i = 0; i < nums.length; i++) {
        for(int j = i + 1; j < nums.length; j++) {
            if(nums[j] = target - nums[i]) {
                return new int[]{i, j};
            }
        }
    }
    throw new IllegalArgumentsException("No tow sum solution");
}

Time complexity: **

Space complexity: **

Solution 2: Tow-pass Hash Table

public int[] towSum(int[] nums, int target) {
    Map<Integer, Integer> map = new HashMap<>();
    for(int i = 0; i < nums.length; i++) {
        map.put(target - nums[i], i);
    }
    for(int i = 0; i < nums.length; i++) {
        if(map.contains(nums[i]) && map.get(nums[i]) != i) {
            return new int[]{i, map.get(nums[i])};
        }
    }
    throw new IllegalArgumentsException("No tow sum solution");
}

Time complexity: **

Space complexity: **

Solution 3: One-pass Hash Table

public int[] twoSum(int[] nums, int target) {
    Map<Integer, Integer> map = new HashMap<>();
    for (int i = 0; i < nums.length; i++) {
        int complement = target - nums[i];
        if (map.containsKey(complement)) {
            return new int[] { map.get(complement), i };
        }
        map.put(nums[i], i);
    }
    throw new IllegalArgumentException("No two sum solution");
}

Time complexity: **

Space complexity: **

全部评论

相关推荐

点赞 收藏 评论
分享
牛客网
牛客企业服务